<?
/*
###############################
#
# J Kirkpatrick Scripts and Plugins Cron Runner
# verified with CC versions 1.98
# http://www.jkirkpatrick.org/
#
###############################
#
# Date: Jan 25, 2005
# Mail: plugins@jkirkpatrick.org
#
#################
#
#Copyright 2004-2005 Jeremiah Kirkpatrick, All rights Reserved
#
###############################
*/
include("../conf.inc.php");
include("../functions.inc.php");
load_plugins();
?>
<html>
<head>
<title>J Kirkpatrick plugin cron job runner for <? echo domain;?></title>
</head>
<body align=left>
<p align=left>This plugin cron job runner is capable of running the cron jobs for the various plugins created by jkirkpatrick.org.
Due to the nature of these plugins the cron job is the single most important job any of the following plugins has, therefore this
file must be used to execute their cron work consistantly.</p>
<ul>
<li>Mailtime</li>
<li>Mailtime (ad free)</li>
<li>Cheat Report by eMail</li>
<li>IMAP Mailcheck</li>
</ul>
<p align=left><em><b>This cron job should be run no more frequently then every 10 minutes!</b></em></p>
<?
$runtime=new cron_timer;
$runtime->start();
$timer_mailtime = new cron_timer;
$timer_mailtime_ad_free = new cron_timer;
$timer_imap_mail_check = new cron_timer;
$timer_crbe = new cron_timer;

?><hr width=80%><?
if($plugin_classes['mailtime'])
{
  reset_exec();
  $timer_mailtime->start();
  echo "<h2 align=left>Executing mailtime cron job...</h2>\n";
  plugin('mailtime','cron_job', '1');
  echo "<p align=left>Mailtime cronjob execution complete.</p>\n";
  $timer_mailtime->stop();
}
?><hr width=80%><?
if($plugin_classes['mailtime_ad_free'])
{
  reset_exec();
  $timer_mailtime_ad_free->start();
  echo "<h2 align=left>Executing Mailtime (Ad Free) cron job...</h2>\n";
  plugin('mailtime_ad_free','cron_job', '1');
  echo "<p align=left>Mailtime (Ad Free) cronjob execution complete.</p>\n";
  $timer_mailtime_ad_free->stop();
}
?><hr width=80%><?
if($plugin_classes['imap_mail_check'])
{
  reset_exec();
  $timer_imap_mail_check->start();
  echo "<h2 align=left>Executing IMAP mailcheck cron job...</h2>\n";
  plugin('imap_mail_check','cron_job', '1');
  echo "<p align=left>IMAP mailcheck cronjob execution complete.</p>\n";
  $timer_imap_mail_check->stop();
}
?><hr width=80%><?
if($plugin_classes['crbe'])
{
  reset_exec();
  $timer_crbe->start();
  echo "<h2 align=left>Executing Cheat report by eMail cron job...</h2>\n";
  plugin('crbe','cron_job', '1');
  echo "<p align=left>Cheat report by eMail cronjob execution complete.</p>\n";
  $timer_crbe->stop();
}
$runtime->stop();
?><hr width=80%>
<table border=0 width=80%>
<tr>
<th align=left>Mailtime Cron Time (seconds)</th>
<td><?echo $timer_mailtime->lapse();?></td>
</tr>
<tr>
<th align=left>Mailtime (Ad Free) Cron Time (seconds)</th>
<td><?echo $timer_mailtime_ad_free->lapse();?></td>
</tr>
<tr>
<th align=left>IMAP mailcheck Cron Time (seconds)</th>
<td><?echo $timer_imap_mail_check->lapse();?></td>
</tr>
<tr>
<th align=left>Cheat report by eMail Cron Time (seconds)</th>
<td><?echo $timer_crbe->lapse();?></td>
</tr>
<tr>
<th align=left><u>Overall Cron Time (seconds)</u></th>
<td><?echo $runtime->lapse();?></td>
</tr>
</table>
<?
function reset_exec()
{
  if(function_exists('set_time_limit'))
  {
     set_time_limit(0);
     echo "<p align=left>cron debug: reseting time limit to 0.</p>";
  }else{
     echo "<p align=left>cron debug: Can't reset time limit, function &quot;set_time_limit&quot; does not exist or is otherwise unavailable.</p>";
  }
}
class cron_timer
{
  var $start_usec;
  var $start_sec;
  var $stop_usec;
  var $stop_sec;
  function cron_timer()
  {
    $this->start_usec=0;
    $this->start_sec=0;
    $this->stop_usec=0;
    $this->stop_sec=0;
  }
  function start(){list($this->start_usec, $this->start_sec)=explode(" ", microtime());}
  function stop(){list($this->stop_usec, $this->stop_sec)=explode(" ", microtime());}
  function reset()
  {
    $this->start_usec=0;
    $this->start_sec=0;
    $this->stop_usec=0;
    $this->stop_sec=0;
  }
  function check($type=0)
  {
    list($t_usec, $t_sec)=explode(" ", microtime());
    $t_usec=$t_usec-$this->start_usec;
    $t_sec=$t_sec-$this->start_sec;
    switch($type)
    {
      default:
      case 0:
        $retval=strval(((float)$t_sec + (float)$t_usec));
        break;
      case 1:
        $retval=((float)$t_usec + (float)$t_sec);
        break;
      case 2:
        $retval=strval($t_sec);
        break;
      case 3:
        $retval=intval($t_sec);
        break;
    }
  return $retval;
  }

  function lapse($type=0)
  {
    $t_usec=$this->stop_usec-$this->start_usec;
    $t_sec=$this->stop_sec-$this->start_sec;
    switch($type)
    {
      default:
      case 0:
        $retval=strval(((float)$t_sec + (float)$t_usec));
        break;
      case 1:
        $retval=((float)$t_sec + (float)$t_usec);
        break;
      case 2:
        $retval=strval($t_sec);
        break;
      case 3:
        $retval=intval($t_sec);
        break;
    }
  return $retval;
  }
}
?>
</body>
</html>
